#pragma once

#include <cstdint>
#include <string>
#include <vector>

#include <GLFW/glfw3.h>
#include <vulkan/vulkan.h>

namespace ls {
  class GlfwState {
    public: 
      GlfwState();
      
      std::vector<const char*> get_vulkan_exts();
  };
  class GlfwWindow {
    private:
      GLFWwindow* __window;
      std::string __title;
    public:
      GlfwWindow(GlfwState* state, uint32_t x_size, uint32_t y_size, std::string title);
      void show();
      void set_title(const std::string title);
      GLFWwindow* __get_backing();
      VkResult __make_surface(VkInstance instance, VkSurfaceKHR* surface);
  };
}
