#include <GLFW/glfw3.h>
#include <cstdlib>
#include <vulkan/vulkan_core.h>
#include <assert.h>

#include "window.hpp"

#include "glfw.hpp"
#include "vulkan.hpp"

namespace ls {
  Window::Window(GlfwState* glfw_state) {
    this->__window = new GlfwWindow(glfw_state, 1920, 1080, "");
  };

  Window::~Window() {
    std::free(this->__window);
  }
  void Window::init_surface(VulkanState* vulkan_state) {
    vulkan_state->__make_surface(__window, &__surface);
  }
  void Window::show() {
    __window->show();
  }
  void Window::set_title(const std::string title) {
    __window->set_title(title);
  }
  GlfwWindow* Window::__get_native() {
    return __window;
  }
}
